/*----------------------------------------------------------------------------
	This is a Virtual Desktop Manager for use under Win32 Shells that
	support the LiteStep 0.24.5 module standard.

	Copyright (C) 2001-2003 Chris Rempel

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
----------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
typedef void (__cdecl *FUNC_VOID__HWND_LPCTSTR)(HWND, LPCTSTR);
typedef void (WINAPI *FUNC_VOID__HWND_BOOL)(HWND, BOOL);

/*--------------------------------------------------------------------------*/
#define SHELL_WINDOW_ID  (0x49474541)
#define VD_SPACING       (10)
#define VD_WIDTH         (g_nDTWidth + VD_SPACING)
#define VD_HEIGHT        (g_nDTHeight + VD_SPACING)

#define VD_ISVALID(x)    ((UINT)(x) >= 0 && (UINT)(x) < g_unDesks)
#define VD_NEXT(x)       ((UINT)(x) < (g_unDesks - 1) ? ((UINT)(x) + 1) : 0)
#define VD_PREV(x)       ((UINT)(x) != 0 ? (x - 1) : (g_unDesks - 1))
#define VD_FIRST         (0)
#define VD_LAST          (g_unDesks - 1)

#define VD_HORIZONTAL    (0x01)
#define VD_VERTICAL      (0x02)
#define VD_HORZVERT      (0x03)

/*--------------------------------------------------------------------------*/
typedef struct _STRINGIDMAP
{
	LPCTSTR const pszStr;
	UINT const unID;
} STRINGIDMAP, *PSTRINGIDMAP;

/*--------------------------------------------------------------------------*/
enum EbvdmStretchMode
{
	 eBVDM_STRETCH__NONE = 0
	,eBVDM_STRETCH__VERTICAL
	,eBVDM_STRETCH__HORIZONTAL
	,eBVDM_STRETCH__BOTH
};

enum EbvdmAlignMode
{
	 eBVDM_ALIGN__NONE = 0
	,eBVDM_ALIGN__LEFT
	,eBVDM_ALIGN__RIGHT
	,eBVDM_ALIGN__TOP
	,eBVDM_ALIGN__BOTTOM
	,eBVDM_ALIGN__CENTER
	,eBVDM_ALIGN__MIDDLE
};

/*--------------------------------------------------------------------------*/
/* Litestep API */
EXTERN_C BOOL AddBangCommand( LPCTSTR, FUNC_VOID__HWND_LPCTSTR );
EXTERN_C BOOL RemoveBangCommand( LPCTSTR );
EXTERN_C BOOL GetRCBool( LPCTSTR, BOOL );
EXTERN_C INT GetRCInt( LPCTSTR, INT );
EXTERN_C BOOL GetRCLine( LPCTSTR, LPTSTR, size_t, LPCTSTR );
EXTERN_C BOOL LCReadNextConfig( UINT, LPCTSTR, LPTSTR, DWORD );
EXTERN_C INT LCTokenize( LPCTSTR, LPTSTR*, DWORD, LPTSTR );
EXTERN_C HINSTANCE LSExecute( HWND, LPCTSTR, INT );
EXTERN_C BOOL match( char *, char * );

/*--------------------------------------------------------------------------*/

	/* SUGGESTED FEATURES and WORKING NOTES */
/*
	Shift VWM origin cmds
!	Move Active Window to VW
	Move all Wnds on specifed VW to other specified VW.
	Gather all Wnds to specified VW of match type
!	Fix PhotoShop tools and similiar
!	Gather all lost windows to specified VW

	Execute command on quit (DONE)
	Variable Number of VW (DONE - need to add gathering)
	Sticky Windows (DONE)
	Execute Command On Switch (DONE)
*/
/*--------------------------------------------------------------------------*/

